import java.awt.*;

/** 
 * Animator.java
 * Thread class for animation
 * @version 1.0
 * @author Byeongseob Ki
 */

class Animator extends Thread {

  GFPlane gf1D = null; 
  GFrame2D gf2D = null; 
  GFrame3D gf3D = null; 

  int speed = 10;
  int mode = 1;

  public Animator(GFPlane gf, int speed) {
     this.gf1D = gf;
     this.speed = speed;
     mode = 1;
  }

  public Animator(GFrame2D gf, int speed) {
     this.gf2D = gf;
     this.speed = speed;
     mode = 2;
  }

  public Animator(GFrame3D gf, int speed) {
     this.gf3D = gf;
     this.speed = speed;
     mode = 3;
  }


  public void run() {
     while (true) {
          try {
             if (speed > 0)
                Thread.sleep(speed);
          } catch (InterruptedException e) {
             System.out.println("Animation error...");
          }
          synchronized(this) {
	    if (mode == 1) {
              if (gf1D.canvas.paintDone) 
                 gf1D.next(true);

            } else if (mode == 2) {
              if (gf2D.canvas.paintDone) 
                 gf2D.next(true);

            } else if (mode == 3) {
              if (gf3D.canvas.paintDone) 
                 gf3D.next(true);
            }
          }
     }
  } 
}









